---
title: CNOE
weight: 5
description: Our top candidate for a platform orchestrator
---

## Summary

In late 2023 platform orchestration raised - the discipline of declarativley dinfing, building, orchestarting and reconciling building blocks of (digital) platforms.

The famost one ist the platform orchestrator from Humanitec. They provide lots of concepts and access, also open sourced tools and schemas. But they do not have open sourced the ocheastartor itself.

Thus we were looking for open source means for platform orchestrating and found [CNOE](https://cnoe.io).

## Requirements for an Orchestrator

When we want to set up a [complete platform](../platforming/platforms-def.drawio.png) we expect to have
* a **schema** which defines the platform, its ressources and internal behaviour
* a **dynamic configuration or templating mechanism** to provide a concrete specification of a platform
* a **deployment mechanism** to deploy and reconcile the platform

This is what [CNOE delivers](https://cnoe.io/docs/intro/approach):

> For seamless transition into a CNOE-compliant delivery pipeline, CNOE will aim at delivering **"packaging specifications"**, **"templating mechanisms"**, as well as **"deployer technologies"**, an example of which is enabled via the idpBuilder tool we have released. The combination of templates, specifications, and deployers allow for bundling and then unpacking of CNOE recommended tools into **a user's DevOps environment**. This enables teams to share and deliver components that are deemed to be the best tools for the job.

## CNOE (capabilities) architecture

### Architecture

CNOE architecture looks a bit different than the reference architecture from Humanitec, but this just a matter of details and arrangement:

> Hint: **This has to be further investigated!** This is subject to an Epic.

<img src="./cnoe-architecture.png" width="600" alt="https://cnoe.io/">

### Capabilities

You have a [definition of all the capabilities here](https://cnoe.io/docs/category/technology-capabilities):

> Hint: **This has to be further investigated!** This is subject to an Epic.

<img src="./cnoe-capabilities.png" width="600" alt="https://cnoe.io/docs/category/technology-capabilities">

## Stacks

CNOE calls the [schema and templating mechnanism 'stacks'](https://github.com/cnoe-io/stacks):

> Hint: **This has to be further investigated!** This is subject to an Epic.

There are already some example stacks:

<img src="./cnoe-stacks.png" width="600">


{{% pageinfo color="info" %}}
### What comes next?

[Next](../cnoe-showtime/) we'll see how a CNOE stacked Internal Developer Platform is deployed on you local laptop!
{{% /pageinfo %}}
